import json
import os
from collections import Counter
from pathlib import Path
from subprocess import check_output

args = []
# args = ["--topo-order"]
commits = check_output(["git", "log", "--pretty=%H", *args], text=True).splitlines()
commits = commits[::len(commits) // min(len(commits), 4096)]
entries = []
last_ctr = Counter()
last_cor = []
cors = []
C = min(len(commits), 720)
for i, commit in enumerate(reversed(commits)):
    print("running", commit, flush=True)
    check_output(["git", "checkout", commit], text=True)
    current_ctr = Counter()
    for path in Path(os.getenv("SRCDIR", "src")).rglob(os.getenv("SRCPATTERN", "*.rs")):
        lines = path.read_bytes().splitlines()
        lines = (line.strip() for line in lines)
        lines = (line for line in lines if line)
        lines = set(lines)
        current_ctr.update(lines)
    added = current_ctr - last_ctr
    deleted = last_ctr - current_ctr
    entries.append((i, current_ctr.total(), added.total(), deleted.total()))
    current_cor = []
    common_ctr = current_ctr & last_ctr
    for j, line in reversed(last_cor):
        if common_ctr[line]:
            common_ctr[line] -= 1
            current_cor.append((j, line))
    current_cor.reverse()
    c = i * C // len(commits)
    for line in added.elements():
        current_cor.append((c, line))
    cor_ctr = Counter(j for j, _ in current_cor)
    assert len(current_cor) == cor_ctr.total() == current_ctr.total()
    while c >= len(cors):
        cors.append([0] * i)
    for j, cor in enumerate(cors):
        cor.append(cor_ctr[j])
    last_ctr = current_ctr
    last_cor = current_cor
with open("/code/metrics.json", "w") as file:
    json.dump({"entries": entries, "cors": cors}, file)
